#include <stdio.h>
#include <stdlib.h>
#include "tvsserver_base.h"
#include "tvs_redefine_api_names.h"
#include "c_example_init.h"
#include "c_example_listen.h"

int __stdcall _StartListening(ProtocolSession *psess, ListenSession *lsess, ClientSession *sess) {
    ProtocolData* pdata = FindProtocolDataStruct(psess, lsess->data);
    MyTCPIPstruct* tcpData_listenSession = (MyTCPIPstruct*) &pdata->data;
    MyTCPIPstruct* tcpData_clientsession;
 
    pdata = FindProtocolDataStruct(psess, sess->data);
    tcpData_clientsession = (MyTCPIPstruct*) &pdata->data;
 
    //start listening on the socket, created by the BindToProtocol function
    tcpData_clientsession->socket = accept(tcpData_listenSession->socket, 0, 0);
 
    if(tcpData_clientsession->socket==INVALID_SOCKET) 
        return 0; //return false
	else
        return 1;
}

//Close the socket
int __stdcall _PrepareCloseListenSession(ProtocolSession *psess, ListenSession *lsess){
    ProtocolData* pdata = FindProtocolDataStruct(psess, lsess->data);
    MyTCPIPstruct* tcpData = (MyTCPIPstruct*) &pdata->data;
	SOCKET mySock;

	//Get socket
	mySock = tcpData->socket;
	//clear tcpData->socket
	tcpData->socket = 0;
	//Close the socket
	closesocket(mySock);

	return 1;
}

int __stdcall _CloseListenSession(ProtocolSession *psess, ListenSession *lsess) {
    ProtocolData* pdata = FindProtocolDataStruct(psess, lsess->data);
    MyTCPIPstruct* tcpData = (MyTCPIPstruct*) &pdata->data;
    MyReplaystruct* replayData = (MyReplaystruct*) &pdata->data;
	
	//If protocol is TCP/IP: close the socket (if not already done)
	if(psess==tcpip_psess) {
		if(tcpData->socket!=0) {
			closesocket(tcpData->socket);
			tcpData->socket = 0;
		}
	//If protocol is Replay: free teh memory for the serverPath
	} else if(psess==replay_psess) {
		if(replayData->serverPath){
			free(replayData->serverPath);
			replayData->serverPath=0;
		}
	}
	return 1;
}